/* Menu Map Vote Plugin
(c) by Sir Drink a lot

Description:
Displays mavotemenu in clanmod style just before map ends.

Commands:
admin_vote_maps <[votetime]>: displays mapvote to all players on server. Optional: overrides standard votetime
admin_vote_stop: cancels mapvote
admin_vote_time <votetime>: sets votetime (player has time to make descision before calculating results, default 60 seconds)
admin_vote_maptime <mapchangetime>: sets time when map changes after vote (default 4 seconds)

Install:
in adminmod.cfg
- file_access_read 1
- amv_enable_beta "menu1"

files:
addons/adminmod/map_vote.ini (put maps into this file)


changelog:
1.3: 
- announcing of timeleft when vote starts stopped, when vote already started.
1.2:
- added some debug messages
*/


#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "1.3";

#define MAX_MAPS 30
#define ITEMS_PER_PAGE 7
#define NEXT	8
#define BACK	9
#define CANCEL	10

new g_File[MAX_TEXT_LENGTH]="addons/adminmod/config/map_vote.ini";
new g_Maps[MAX_MAPS][MAX_TEXT_LENGTH];
new g_loaded;

new g_UserMenu[MAX_PLAYERS];
new g_UserSelect[MAX_PLAYERS];

new g_MapsSelect[MAX_MAPS];
new g_UserMapSelect[MAX_PLAYERS]={-1,-1,...};

new g_timerindex;
new g_extend;
new g_maxextend;
new g_CurrentMap[MAX_NAME_LENGTH];
new g_NextMap[MAX_NAME_LENGTH];

new g_votetime;
new g_mapchangetime;

new g_OrigTimelimit;
new g_Timelimit;
new g_Timer;
new g_vote_started;

public plugin_init() {
	new Text[MAX_TEXT_LENGTH];
	new Cvar[MAX_NAME_LENGTH];
	new iFileAccess;
	new menu1=1;
	new file=1;
	
	getstrvar("amv_enable_beta",Cvar,MAX_NAME_LENGTH);
	if(strstrx(Cvar,"menu1")==-1){
		menu1=0;
		snprintf(Text,MAX_TEXT_LENGTH,"* [MAP-VOTE] ERROR: No amv_enable_beta ^"menu1^" is set in adminmod.cfg!");
		log(Text);
	}
	
	file=fileexists(g_File);
	if(!file){
		snprintf(Text,MAX_TEXT_LENGTH,"* [MAP-VOTE] ERROR: %s not found!",g_File);
		log(Text);
	}
	
	iFileAccess=getvar("file_access_read");
	
	if(iFileAccess && menu1 && file){
			plugin_registerinfo("Menu Map Vote Plugin","Map Vote in Clanmod-Style",AM_VERSION_STRING);
			plugin_registercmd("admin_vote_maps","am_vote_maps",ACCESS_VOTE_MAP, "admin_vote_maps <[votetime]>: displays mapvote to all players on server. Optional: overrides standard votetime");
			plugin_registercmd("admin_vote_stop","am_vote_stop",ACCESS_VOTE_MAP, "admin_vote_stop: cancels mapvote");
			plugin_registercmd("admin_vote_time","am_vote_time",ACCESS_VOTE_MAP, "admin_vote_time <votetime>: sets votetime");
			plugin_registercmd("admin_vote_maptime","am_vote_maptime",ACCESS_VOTE_MAP, "admin_vote_maptime <mapchangetime>: sets time when map changes after vote.");

			plugin_registercmd("admin_vote_debug","am_vote_debug",ACCESS_VOTE_MAP);

			plugin_registercmd("say_team","HandleSay",ACCESS_ALL,"say votemaps: opens votemenu");
			plugin_registercmd("say","HandleSay",ACCESS_ALL,"say votemaps: opens votemenu");

			//check for selection
			plugin_registercmd("menuselect","menuselect",ACCESS_ALL);

			//cancel vote_menu
			plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
			plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
			plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
			plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
			plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
			plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
			plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);

			//destroy HL-Console Command votemaps
			plugin_registercmd("votemaps","votemaps",ACCESS_ALL);

			if(!get_vaultnumdata("MENU_VOTE_TIME",g_votetime)){
				set_vaultnumdata("MENU_VOTE_TIME",60);
				g_votetime=60;
			}

			if(!get_vaultnumdata("MENU_VOTE_MAPCHANGE",g_mapchangetime)){
				set_vaultnumdata("MENU_VOTE_MAPCHANGE",4);
				g_mapchangetime=4;
			}
			currentmap(g_CurrentMap,MAX_NAME_LENGTH);
			nextmap(g_NextMap,MAX_NAME_LENGTH);
			g_maxextend=getvar("admin_vote_maxextend");

			g_OrigTimelimit=getvar("mp_timelimit");
			g_Timelimit=getvar("mp_timelimit");

			g_Timer=set_timer("timer_vote",g_Timelimit*60-g_votetime-g_mapchangetime,0);
			set_timer("check_timer",30,99999);
			read_file();
			return PLUGIN_CONTINUE;
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"* [MAP-VOTE] ERROR: No file_access_read is set to 1 in adminmod.cfg!");
		log(Text);
	}
	plugin_registerinfo("Menu Map Vote Plugin","PLUGIN DISABLED! TO MANY ERRORS! CHECK LOGFILES!",AM_VERSION_STRING);
	return PLUGIN_CONTINUE;
}

read_file(){
	new iFileSize;
	new i;
	iFileSize=filesize(g_File);
	if(iFileSize>=MAX_MAPS){
		iFileSize=MAX_MAPS-1;
	}
	for(i=1;i<=iFileSize;i++){
		readfile(g_File,g_Maps[g_loaded],i,MAX_TEXT_LENGTH);
		g_loaded++;
	}
	g_loaded--;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		reset_array(UserIndex);
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Vote-Menu is closed by another menu!");
		messageex(UserName,Text,print_chat);
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

reset_array(UserIndex){
	g_UserSelect[UserIndex]=0;
	g_UserMenu[UserIndex]=0;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(strcmp(Data,"votemaps")==0){
		execclient(UserName,"menuselect 10");
		execclient(UserName,"votemaps");
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public check_timer(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new iTimeleft=timeleft(0);
	

	g_Timelimit=getvar("mp_timelimit");
	
	if(!g_vote_started){
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] timeleft till mapvote: %i minutes",(iTimeleft-g_votetime-g_mapchangetime)/60);
		say(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] has started! Please make your votes! Use ^"votemaps^" in chat to change your vote!");
		say(Text);
	}	
	if(g_Timelimit!=g_OrigTimelimit){
		if(get_timer(g_Timer)>0){
			kill_timer(g_Timer);
			g_Timer=0;
		}
		new iVote;
		iVote=iTimeleft-g_votetime-g_mapchangetime;
		if(iVote>0){
			g_OrigTimelimit=g_Timelimit;
			g_Timer=set_timer("timer_vote",iVote,0);
		}
	}
}
	

public timer_vote(Timer,Repeat,HLName,HLParam) {
	plugin_exec("admin_vote_maps","");
}

public am_vote_maps(HLCommand,HLData,HLUserName,UserIndex){
	if(vote_allowed() && !g_vote_started){	
		new Text[MAX_TEXT_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new Player[MAX_NAME_LENGTH];
		new i;
		new ivotetime;
		new maxplayers=maxplayercount();
		
		g_vote_started=1;

		convert_string(HLData,Data,MAX_DATA_LENGTH);

		if(strlen(Data)!=0){
			ivotetime=strtonum(Data);
			if(ivotetime<=0){
				ivotetime=g_votetime;
			}
		}else{
			ivotetime=g_votetime;
		}

		g_timerindex=set_timer("calc_vote",ivotetime,0);
		
		if(g_Timer){
			g_Timer=0;
		}

		snprintf(Text,MAX_TEXT_LENGTH,"Please make your map decision!^nUse ^"votemaps^" in chat!^nYou have %i seconds for vote!!",ivotetime);
		centersay(Text,12,255,255,255);
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Please make your map decision! Use ^"votemaps^" in chat! You have %i seconds for vote!!",ivotetime);
		say(Text);

		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Player,MAX_NAME_LENGTH)){
				execclient(Player,"menuselect 10");
				speakto(Player,"gman/gman_choose2");
				execclient(Player,"votemaps");
			}
		}
	}else{
		selfmessage("[MAP-VOTE] A map vote is not allowed at the moment!");
	}
	return PLUGIN_HANDLED;
}

public votemaps(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	vote_menu(UserName,UserIndex);
	return PLUGIN_HANDLED;
}

vote_menu(UserName[],UserIndex){
	new Text[512];
	new i;
	new x;
	new keys;
	new key=1;
	
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE]^n");
	for(i=g_UserSelect[UserIndex];i<=g_loaded;i++){
		x++;
		if(x>ITEMS_PER_PAGE){
			break;
		}else{
			if(strcmp(g_Maps[i],g_CurrentMap)==0 && g_extend<g_maxextend){
				snprintf(Text,512,"%s^n\y%i. Extend (%i)",Text,x,g_MapsSelect[i]);
				keys |= key;
			}else if(strcmp(g_Maps[i],g_CurrentMap)==0 && g_extend>=g_maxextend){
				snprintf(Text,512,"%s^n\r%i. Extend",Text,x);
			}else if(strcmp(g_Maps[i],g_NextMap)==0){
				snprintf(Text,512,"%s^n\r%i. %s",Text,x,g_Maps[i]);
			}else{
				snprintf(Text,512,"%s^n\y%i. %s (%i)",Text,x,g_Maps[i],g_MapsSelect[i]);
				keys |= key;
			}
		}
		key <<= 1;
	}
	snprintf(Text,MAX_TEXT_LENGTH,"%s^n",Text);
	if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE < g_loaded){
		if(g_UserSelect[UserIndex]==0){
			strcat(Text,"\w^n8. Next",512);
			keys+=128;
		}else{
			strcat(Text,"\w^n8. Next - 9. Back",512);
			keys+=384;
		}
	}else if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE >= g_loaded && g_UserSelect[UserIndex]!=0){
		strcat(Text,"\w^n9. Back",512);
		keys+=256;
	}
	strcat(Text,"\r^n0. Cancel",512);
	keys+=512;
	g_UserMenu[UserIndex]=1;
	menu(UserName,Text,keys);
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new iSelect;
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		iSelect=strtonum(Data);
		if(iSelect==NEXT){ 	
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]+ITEMS_PER_PAGE;
			vote_menu(UserName,UserIndex);
		}else if(iSelect==BACK){
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]-ITEMS_PER_PAGE;
			vote_menu(UserName,UserIndex);
		}else if(iSelect==CANCEL){
			reset_array(UserIndex);
		}else{
			g_UserSelect[UserIndex]+=iSelect-1;
			if(g_UserMapSelect[UserIndex]!=-1){
				snprintf(Data,MAX_DATA_LENGTH,"[MAP-VOTE] %s removed his previous vote for %s",UserName,g_Maps[g_UserMapSelect[UserIndex]]);
				say(Data);
				g_MapsSelect[g_UserMapSelect[UserIndex]]-=1;
			}
			snprintf(Data,MAX_DATA_LENGTH,"[MAP-VOTE] %s voted for %s",UserName,g_Maps[g_UserSelect[UserIndex]]);
			say(Data);
			g_MapsSelect[g_UserSelect[UserIndex]]+=1;
			g_UserMapSelect[UserIndex]=g_UserSelect[UserIndex];
			reset_array(UserIndex);
		}
	}
	return PLUGIN_CONTINUE;
}

public am_vote_stop(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	if(g_timerindex!=0){
		kill_timer(g_timerindex);
		g_timerindex=0;
		g_vote_started=0;
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Map vote canceled!");
		//calculate new automatic vote
		set_timer("check_timer",1,0);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] No vote started or vote has finished!");
	}
	say(Text);
	return PLUGIN_HANDLED;
}

public am_vote_time(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		iData=strtonum(Data);
		if(iData>=0){
			set_vaultnumdata("MENU_VOTE_TIME",iData);
			g_votetime=iData;
			//calculate new automatic vote
			if(get_timer(g_Timer)>0){
				kill_timer(g_Timer);
				g_Timer=0;
			}
			set_timer("check_timer",1,0);
		}
	}
	
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] map vote time is set to %i seconds!",g_votetime);	
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

public am_vote_maptime(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		iData=strtonum(Data);
		if(iData>=0){
			set_vaultnumdata("MENU_VOTE_MAPCHANGE",iData);
			g_mapchangetime=iData;
			//calculate new automatic vote
			if(get_timer(g_Timer)>0){
				kill_timer(g_Timer);
				g_Timer=0;
			}
			set_timer("check_timer",1,0);
		}
	}
	
	snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] map change time is set to %i seconds!",g_mapchangetime);	
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

public am_vote_debug(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new Player[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	
	snprintf(Text,MAX_TEXT_LENGTH,"******* [MAP-VOTE] *******");
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Settings:");
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Currentmap: %s",g_CurrentMap);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* Nextmap: %s",g_NextMap);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* current map extends: %i",g_extend);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* max map extends: %i",g_maxextend);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* vote started: %i",g_vote_started);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* votetime: %i",g_votetime);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* mapchangetime: %i",g_mapchangetime);
	selfmessage(Text);
	selfmessage("**************************");
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			snprintf(Text,MAX_TEXT_LENGTH,"* Player: %s",Player);
			selfmessage(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"* - in menu: %i",g_UserMenu[i]);
			selfmessage(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"* - his select: %i",g_UserSelect[i]);
			selfmessage(Text);
			if(g_UserMapSelect[UserIndex]!=-1){
				snprintf(Text,MAX_TEXT_LENGTH,"* - his map select: %s",g_Maps[g_UserMapSelect[UserIndex]]);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"* - his map select: no map selected");
			}
			selfmessage(Text);
		}
	}
	selfmessage("**************************");
	snprintf(Text,MAX_TEXT_LENGTH,"* map_vote.ini: %s",g_File);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"* loaded maps: %i",g_loaded);
	selfmessage(Text);
	for(i=0;i<=g_loaded;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"* map (x): %s (%i)",g_Maps[i],g_MapsSelect[i]);
		selfmessage(Text);
	}
	
	return PLUGIN_HANDLED;
}


public calc_vote(Timer,Repeat,HLName,HLParam) {
	new Text[MAX_TEXT_LENGTH];
	new iWinning=MAX_MAPS;
	new ifound;
	new i;
		
	g_timerindex=0;
	g_Timer=0;
	
	for(i=0;i<=g_loaded;i++){
		if(g_MapsSelect[i]!=0){
			if(g_MapsSelect[iWinning]<g_MapsSelect[i]){
				iWinning=i;
				ifound=1;
			}else if(g_MapsSelect[iWinning]==g_MapsSelect[i]){
				ifound=0;
			}
		}
	}
	if(ifound){
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] %s wins with %i votes.",g_Maps[iWinning],g_MapsSelect[iWinning]);
		say(Text);

		if(strcmp(g_CurrentMap,g_Maps[iWinning])==0){
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Extend %s for 15 minutes.",g_Maps[iWinning]);
			say(Text);
			g_Timelimit += 15;
			snprintf(Text,MAX_TEXT_LENGTH,"mp_timelimit %i",g_Timelimit);
			exec(Text);
			g_extend++;
			g_vote_started=0;
			//calculate new automatic vote
			set_timer("check_timer",1,0);
		}else{
			set_timer("map_change",g_mapchangetime,0,g_Maps[iWinning]);
			snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] Changing to %s in %i seconds.",g_Maps[iWinning],g_mapchangetime);
			say(Text);
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[MAP-VOTE] No map gots enough votes! Vote failed!");
		say(Text);
	}
	new maxplayers=maxplayercount();
	for(i=1;i<=maxplayers;i++){
		g_UserMapSelect[i]=-1;
	}
	for(i=0;i<=g_loaded;i++){
		g_MapsSelect[i]=0;
	}
}
		
public map_change(Timer,Repeat,HLName,HLParam) {
	new Map[MAX_NAME_LENGTH];
	convert_string(HLParam,Map,MAX_NAME_LENGTH);
	changelevel(Map,4);
}